net.sf.saxon.value

## Class SingletonItem<T extends Item>

- java.lang.Object
- - net.sf.saxon.value.SingletonItem<T>

- All Implemented Interfaces:
    GroundedValue, Sequence

      public class SingletonItem<T extends Item>
      extends Object
      implements GroundedValue

  A value that is a sequence containing zero or one items. Used only for nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected T` | `item`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SingletonItem(T item)` Create a sequence containing zero or one items

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `asItem()` Return the value in the form of an Item
    `boolean` | `effectiveBooleanValue()` Get the effective boolean value
    `int` | `getCardinality()` Determine the static cardinality
    `int` | `getLength()` Get the length of the sequence
    `String` | `getStringValue()` Convert the value to a string, using the serialization rules.
    `CharSequence` | `getStringValueCS()` Get the string value of this sequence.
    `Item` | `head()` Get the first item in the sequence.
    `T` | `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
    `SequenceIterator<T>` | `iterate()` Return an enumeration of this nodeset value.
    `void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
    `GroundedValue` | `reduce()` Reduce the sequence to its simplest form.
    `GroundedValue` | `subsequence(int start, int length)` Get a subsequence of the value
    `String` | `toString()` Returns a string representation of the object.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### item

          protected T extends Item item

  - ### Constructor Detail

    - #### SingletonItem

          public SingletonItem(T item)

      Create a sequence containing zero or one items
      Parameters:
        `item` - The node or function-item to be contained in the sequence, or null if the sequence is to be empty

  - ### Method Detail

    - #### getStringValueCS

          public CharSequence getStringValueCS()
                                        throws XPathException

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### head

          public Item head()
                    throws XPathException

      Get the first item in the sequence.
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty
      Throws:
        `XPathException` - in the situation where the sequence is evaluated lazily, and evaluation of the first item causes a dynamic error.

    - #### asItem

          public T asItem()

      Return the value in the form of an Item
      Returns:
        the value in the form of an Item

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the instruction, without returning any tail calls
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException`

    - #### getCardinality

          public int getCardinality()

      Determine the static cardinality

    - #### getLength

          public int getLength()

      Get the length of the sequence
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### itemAt

          public T itemAt(int n)

      Get the n'th item in the sequence (starting from 0). This is defined for all SequenceValues, but its real benefits come for a SequenceValue stored extensionally (or for a MemoClosure, once all the values have been read)
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, with 0 representing the first item in the sequence
      Returns:
        the n'th item if it exists, or null otherwise

    - #### subsequence

          public GroundedValue subsequence(int start,
                                  int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence. If min is

    - #### iterate

          public SequenceIterator<T> iterate()

      Return an enumeration of this nodeset value.
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over all the items

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()

      Get the effective boolean value
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value

    - #### getStringValue

          public String getStringValue()

      Convert the value to a string, using the serialization rules. For atomic values this is the same as a cast; for sequence values it gives a space-separated list. For QNames and NOTATIONS, or lists containing them, it fails.
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### toString

          public String toString()

      Returns a string representation of the object.
      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of the object.

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of SingletonItem. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.